package com.connor.processAttributeModification;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import com.connor.jingdiao.handlers.StandardDialog;
import com.connor.jingdiao.handlers.StandardDialog.TextAreaRenderer;
import com.connor.jingdiao.util.TCUtil;
import com.connor.ml.tcm.outfile.util.MethodUtil;
import com.teamcenter.rac.aif.kernel.AIFComponentContext;
import com.teamcenter.rac.aifrcp.AIFUtility;
import com.teamcenter.rac.kernel.ListOfValuesInfo;
import com.teamcenter.rac.kernel.TCComponent;
import com.teamcenter.rac.kernel.TCComponentActionHandler;
import com.teamcenter.rac.kernel.TCComponentDataset;
import com.teamcenter.rac.kernel.TCComponentItem;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCComponentListOfValues;
import com.teamcenter.rac.kernel.TCComponentListOfValuesType;
import com.teamcenter.rac.kernel.TCComponentTask;
import com.teamcenter.rac.kernel.TCComponentTaskTemplate;
import com.teamcenter.rac.kernel.TCComponentTcFile;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCHandlerType;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;

import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.util.ArrayUtil;

public class ProcessAttriChangeDialog extends JDialog {
	private static final long serialVersionUID = 1L;
	
	private TCSession session;
	private TCComponent[] modelsF;
	private TCComponentTask taskF;
	private LinkedHashMap<String, String[]> ruleOpsMapF = new LinkedHashMap<>();
	private int[] colsF;
	private JButton remarkBtn;
	private JButton exportBtn;
	private JButton closeBtn;
	private JTable impTable;
	private DefaultTableModel impModel;
	/**
	 * ޸
	 */
	private JPanel propertyPanel;
	private ArrayList<TCComponentItemRevision> revlist;
	/**
	 * ݣ[rev,object_name] ͣ
	 */
	private String[] mark;
	private int mrow = -1;
	/**
	 * űֶ
	 */
	private List<String> tableHeaderList = new ArrayList<>();

	/**
	 * õ̲:keyΪʵֵ(object_name)valueΪʾڿϵ()
	 */
	private Map<String, String> argMap = new HashMap<String, String>();
	/**
	 * 洢̲:keyΪʵֵ(object_name)valueΪ(ڻȡֵ)
	 */
	private Map<String, Object> textAreaMap = new HashMap<>(); // ڱJTextArea
	
	private Map<String, Object> testAnySR = new HashMap<String, Object>();
	/**
	 * ǰѡеtableжӦİ汾
	 */
	private List<TCComponentItemRevision> targetRevision = new ArrayList<TCComponentItemRevision>();

	private JPanel topPanel = null;
	/**
	 * ȫֱѡе
	 */
	private List<Integer> chooseRows = new ArrayList<Integer> ();

	/**
	 *
	 * @param session Ự
	 * @param models
	 * @param task ڵ
	 * @param ruleOpsMap keyΪ()valueΪһString[]飬String["item/rev","object_name"]
	 * @param cols
	 * @param chooseRows2 
	 * @throws Exception
	 */
	public ProcessAttriChangeDialog(
			TCSession session, 
			TCComponent[] models, 
			TCComponentTask task, 
			LinkedHashMap<String, String[]> ruleOpsMap, 
			int[] cols, List<Integer> chooseRowsA, 
			List<TCComponentItemRevision> targetRevisionA)
			throws Exception {
		super(AIFUtility.getActiveDesktop());
		this.session = session;
		this.modelsF = models;
		this.taskF = task;
		this.ruleOpsMapF = ruleOpsMap;
		this.chooseRows = chooseRowsA;
		this.targetRevision = targetRevisionA;
		if (chooseRowsA != null && chooseRowsA.size()>0) {
			System.out.println("캯ProcessAttriChangeDialogchooseRowsA:"+chooseRowsA.toString());
		}else {
			if (this.chooseRows != null) {
				System.out.println("this.chooseRows:["+this.chooseRows.size()+"]");
			}
			System.out.println("캯ProcessAttriChangeDialogchooseRowsAΪգ");
		}
		this.colsF = cols;
		this.argMap = getHandlerArgs(task);
		initUi( modelsF, taskF, ruleOpsMapF, colsF,chooseRowsA);
	}

	/**
	   *   ʼ
	 * @param session
	 * @param models
	 * @param task
	 * @param ruleOpsMapI keyΪ()valueΪһString[]飬String["item/rev","object_name"]
	 * @param cols
	 * @param chooseRows ʼʱЯѡ
	 * @throws Exception 
	 */
	private void initUi(TCComponent[] models,
						TCComponentTask task,
						LinkedHashMap<String, String[]> ruleOpsMapI,
						int[] cols, List<Integer> chooseRows2) throws Exception {
//		this.chooseRows.addAll(chooseRows2);
		if (chooseRows2 != null && chooseRows2.size()>0) {
			System.out.println("ǰѡ="+Arrays.toString(chooseRows2.toArray()));
		}else {
			System.out.println("initUi-ǰʱδѡκУ");
		}
		
		System.out.println("ʼʼ/ˢ塤");
		setTitle("༭ڵ");
		remarkBtn = new JButton("޸");
		
		exportBtn = new JButton("Excel");
		closeBtn = new JButton("ر");
		JPanel btnPanel = new JPanel(new FlowLayout());
		btnPanel.add(remarkBtn);
		btnPanel.add(exportBtn);
		btnPanel.add(closeBtn);

		if (topPanel == null) {
			topPanel = new JPanel(new BorderLayout());

		} else {
			topPanel.removeAll();
		}

		//TODO ع
		if (this.argMap.isEmpty()){
			MessageBox.post(ProcessAttriChangeDialog.this, "ȡHandlerϢʧܣã", "ERROR", MessageBox.ERROR);
			return;
		}
		// 
		propertyPanel = new JPanel(new PropertyLayout());
//		int k = 0;
//		for (String key : this.argMap.keySet()) {//õȾ
//			k++;
//			String value = this.argMap.get(key);//ʾ
//			System.out.println("ϢKey: " + key + ", Value: " + value);
//			String labLocation = String.valueOf(k)+".1.left.top";
//			String fieldLocation = String.valueOf(k)+".2.left.top";
//			propertyPanel.add(labLocation,new JLabel(value));
//
//			//TODO ߼عݲͬͣȾͬ
//			String[] attrs = ruleOpsMapI.get(value);
//			if (attrs == null || attrs.length == 0){
//				System.out.println("infoʾֶΡ"+value+"ȡϢʧܣѡã");
//			}
//			String currentAttributeValue = null;//ǰԵֵȾ
//			System.out.println("====================================================================");
//			if (this.targetRevision != null && this.targetRevision.size() > 0){
//				System.out.println("infoѡж󣬿ʼѡжȾ");
//
//				//ѡжʱĬϽǰѡеĵһΪĬֵȾԱ༭
//				TCComponentItem targetItem = this.targetRevision.get(0).getItem();
//				//ƻȡͣitem/rev
//				String itemType = attrs[0];//item/rev
//				String propertyName = attrs[1];//ʵ
//				if (itemType.equals("item")){
//					currentAttributeValue = targetItem.getProperty(propertyName);//ȡǰԵֵ
//
//				}else {
//					currentAttributeValue = targetRevision.get(0).getProperty(propertyName);//ȡǰԵֵ
//
//				}
//				//
//				if (isLovType(propertyName)){
//					System.out.println("ԡ"+propertyName+"ΪLOV");
//
//					Map<String, String> lovList = getUnitValue_display(session,propertyName);
//					// б
//					JComboBox<String> comboBox = new JComboBox<>();
//
//					// lovListеvalueֵӵб
//					for (String lovValue : lovList.values()) {
//						comboBox.addItem(lovValue);
//					}
//					// ĬʾֵdefaultValueϣĬʾѡ
//					comboBox.setSelectedItem(currentAttributeValue);
//					propertyPanel.add(fieldLocation, comboBox);
//					this.textAreaMap.put(propertyName, comboBox); //
//				}else {//
//					System.out.println("ԡ"+ propertyName+"ͷLOV	");
//
//					JTextArea textArea = new JTextArea(); // JTextArea
//					textArea.setColumns(20); // 
//					textArea.setLineWrap(true); // Զ
//					textArea.setWrapStyleWord(true); // ʻ
//					JScrollPane scrollPane = new JScrollPane(textArea);
//					System.out.println("KUMA=" + value);
//					if (value != null && (value.trim().contains("ע") || "ע".equals(value.trim()))){//ע⴦Ӹ߶
//						System.out.println("KUMA:ֶ⴦");
//						scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
//						textArea.setRows(3);
//						scrollPane.setPreferredSize(scrollPane.getPreferredSize()); //  JScrollPane ѡߴ
//					}
//					//ֵtextArea
//					textArea.setText(currentAttributeValue);
//					propertyPanel.add(fieldLocation, scrollPane);
//					this.textAreaMap.put(key, textArea); // JTextArea浽Map
//				}
//
//			}else {
//				System.out.println("infoδѡκУ޷ȡѡжȾĬ");
//				//ȾĬ
//				JTextArea textArea = new JTextArea(); // JTextArea
//				textArea.setColumns(20); // 
//				textArea.setLineWrap(true); // Զ
//				textArea.setWrapStyleWord(true); // ʻ
//				propertyPanel.add(fieldLocation, new JScrollPane(textArea));
//				this.textAreaMap.put(key, textArea); // JTextArea浽Map
//			}
//		}

		// λãbtnPanel ϱߣײ
		topPanel.add(propertyPanel, BorderLayout.CENTER);
		topPanel.add(btnPanel, BorderLayout.SOUTH);

		topPanel.revalidate();
		topPanel.repaint();
		
		//ͷ
		String[] tableHeader = new String[ruleOpsMapI.size() + 1];
		tableHeader[0] = "";
		int h = 1;
		for (String s : ruleOpsMapI.keySet()) {
			tableHeader[h] = s;
				mark = ruleOpsMapI.get(s);
			h++;
		}
		//ӵб
		for (String tableHeader2 : tableHeader){
			tableHeaderList.add(tableHeader2);
		}
		impModel = new DefaultTableModel(tableHeader, 0);
		impTable = new JTable() {
			private static final long serialVersionUID = 1L;
			@Override
			public boolean isCellEditable(int row, int col) {
				return false;
			}
		};
		impTable.getTableHeader().setReorderingAllowed(false);
		impTable.setFillsViewportHeight(true);
		impTable.setEnabled(true);
		impTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		impTable.setModel(impModel);
		impTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		
		for (int i = 1; i < impModel.getColumnCount(); i++) {
			TableColumn col = impTable.getColumnModel().getColumn(i);
			col.setCellRenderer(new TextAreaRenderer());
			col.setPreferredWidth(150);
		}
		
		setDatas(task, (TCComponentDataset) models[0], ruleOpsMapI);
//		// Ƴɵļ
//		for (MouseListener listener : impTable.getMouseListeners()) {
//			impTable.removeMouseListener(listener);
//		}
		addActionListener(models, cols);

		setLayout(new BorderLayout());
		topPanel.setPreferredSize(new Dimension(260, getHeight())); // ÿ
		add(BorderLayout.EAST, topPanel);
		add(BorderLayout.CENTER, new JScrollPane(impTable));
		pack();
		setSize(new Dimension(1400, 500));
		setDefaultLookAndFeelDecorated(true);
		Dimension screen = getToolkit().getScreenSize();
		setLocation((screen.width - getSize().width) / 2, (screen.height - getSize().height) / 2);
		setAlwaysOnTop(true);
		setVisible(true);

		//ѡУtableѡжӦ״̬
		if (chooseRows != null && chooseRows.size() > 0) {
			System.out.println("¼ɣǰѡУʼtableѡ״̬");
			List<Integer> uniqueRows = new ArrayList<>(new HashSet<>(chooseRows)); // ȥ
			Collections.sort(uniqueRows); // 
			for (int row : uniqueRows) {
				impTable.addRowSelectionInterval(row, row);
			}
		}else{
			System.out.println("¼ɣǰδѡκУ¼tableѡ״̬");
		}

	}

	/**
	 * жǷΪlov
	 * @param attrName ֶ
	 * @return
	 */
	private boolean isLovType(String attrName){
		System.out.println("isLovTypeжǷLOV~");
		TCComponentListOfValuesType lovType;
		try {
			lovType = (TCComponentListOfValuesType) session.getTypeComponent("ListOfValues");
			TCComponentListOfValues[] lov = lovType.find(attrName);
			if (lov.length > 0)
				return true;
		} catch (TCException e) {
			System.out.println("ȡLOV쳣");
			e.printStackTrace();
		}
		return false;
	}

	/**
	 * TC LOVֵ<ʵֵ,ʾֵ>
	 * @param seesion
	 * @return
	 * @throws TCException
	 */
	private static Map<String, String> getUnitValue_display(TCSession seesion,String lovProp) throws TCException
	{
		Map<String, String> value_displays = new HashMap<String, String>();
		TCComponentListOfValues unitLov = getLov(seesion, lovProp);
		if(unitLov !=null)
		{
			ListOfValuesInfo listOfValues = unitLov.getListOfValues();
			String[] realval = listOfValues.getStringListOfValues();
			String value="";
			boolean flag = false;
			for (int i = 0; i < realval.length; i++) {
				String disval = listOfValues.getDisplayableValue(realval[i]);
				value_displays.put(realval[i], disval);
			}
		}
		return value_displays;
	}

	private static TCComponentListOfValues getLov(TCSession session, String lovName) {
		TCComponentListOfValuesType lovType;
		try {
			lovType = (TCComponentListOfValuesType) session.getTypeComponent("ListOfValues");
			TCComponentListOfValues[] lov = lovType.find(lovName);
			if (lov.length > 0)
				return lov[0];
		} catch (TCException e) {
			e.printStackTrace();
		}
		return null;
	}
	 
	/**
	 * ڵȡ̲
	 * @param task
	 * @return
	 * @throws TCException 
	 */
	private Map<String, String> getHandlerArgs(TCComponentTask task) throws TCException {
		System.out.println("getHandlerArgs~");
		Map<String, String> returnHandlerArgMap = new HashMap<String, String>();
		TCComponent handlerComp = task.getHandler(TCHandlerType.ACTION, TCComponentTaskTemplate.COMPLETE_ACTION, "j6_Standard");//Connor_check_process_member
		if (handlerComp == null) {
			MessageBox.post(ProcessAttriChangeDialog.this, "ݽڵȡhandlerʧܣ", "ERROR", MessageBox.ERROR);
			return null ;
		}
		TCComponentActionHandler handler = (TCComponentActionHandler) handlerComp;
		String[] args = handler.getArguments();//ȡ̲飬ÿ "argName=argValue"
		if (args == null) {
			MessageBox.post(ProcessAttriChangeDialog.this, "ȡµĲʧܣ", "ERROR", MessageBox.ERROR);
			return null ;
		}
		for (int j = 0; j < args.length; j++) {
			System.out.println("handler param: " + args[j]);
			int ind = args[j].indexOf("=");
			if (ind <= 0) {
				continue;
			}
			String argName = args[j].substring(0, ind);
			String argValue = args[j].substring(ind + 1);
			returnHandlerArgMap.put(argName, argValue);
		}
		return returnHandlerArgMap;
	}
	

	@SuppressWarnings("rawtypes")
	private void setDatas(TCComponentTask task, TCComponentDataset model, LinkedHashMap<String, String[]> ruleOpsMap) throws Exception {
		System.out.println("ʼִsetDatas");
		TCComponentTcFile[] files = model.getTcFiles();
		File file = files[0].getFile(System.getProperty("java.io.tmpdir"));
		SAXReader saxReader = new SAXReader();
		Document doc = saxReader.read(file);
		Element root = doc.getRootElement();
		Element condizione = root.element("condizione");
		List typeEs = condizione.element("object_type").elements();
		ArrayList<String> types = new ArrayList<>();
		for(Object e : typeEs) {
			types.add(((Element)e).getText());
		}
		List regolaEs = condizione.element("regola").elements();
		HashMap<String, Boolean> regolas = new HashMap<>();
		for(Object e : regolaEs) {
			String t = ((Element)e).getText();
			String name = ((Element)e).getName();
			if(name.equals("item"))
				name = "object_type";
			if(t.equals("*")) {
				regolas.put(name, false);
			}else {
				regolas.put(name, true);
			}
		}
		List rows = root.element("data").elements();
		AIFComponentContext[] contexts = TCUtil.getPseudoFolder(task, "root_target_attachments").getChildren();
		revlist = new ArrayList<>();
		for(AIFComponentContext c : contexts) {
			if(!types.contains(c.getComponent().getType()))
				continue;
			TCComponentItemRevision rev = (TCComponentItemRevision) c.getComponent();
			HashMap<String, String> props = new HashMap<>();
			for(String s : regolas.keySet()) {
				if(rev.getTCProperty(s) == null) {
					System.out.println(rev+" >> "+s+"\nδҵ");
					throw new Exception("жôϢ");
				}
				props.put(s, rev.getProperty(s));
			}
			ROW:for(Object e : rows) {
				for(Object t : ((Element)e).elements()) {
					String name = ((Element)t).getName();
					if(!props.containsKey(name))
						continue;
					String text = ((Element)t).getText();
					String val = props.get(name);
					if(regolas.get(name)) {
						if(text.equals("null")) {
							if(!val.isEmpty())
								continue ROW;
						}else if(!val.equals(text))
							continue ROW;
					}else if(!regolas.get(name) && !val.contains(text)) {
						continue ROW;
					}
				}
				TCComponentItem item = rev.getItem();
				String[] row = new String[ruleOpsMap.size()+1];
				row[0] = impTable.getRowCount()+1+"";
				int i = 1;
				for(String n : ruleOpsMap.keySet()) {
					row[i] = getProp(ruleOpsMap.get(n), item, rev);
					i++;
				}
				System.out.println("row:"+Arrays.toString(row));
				impModel.addRow(row);
				System.out.println("kumarev");
				revlist.add(rev);
				break;
			}
		}
	}

	/**
	 * Ա༭Panel
	 * @throws TCException 
	 *
	 */
	private void updatePropertyPanel(LinkedHashMap<String, String[]> ruleOpsMapI) throws TCException {
		System.out.println("updatePropertyPanel~");
		//1.ǰPanel
		propertyPanel.removeAll();
		topPanel.remove(propertyPanel);
		propertyPanel = new JPanel(new PropertyLayout());

		int k = 0;
		for (String key : this.argMap.keySet()) {//õȾ
			k++;
			String value = this.argMap.get(key);//ʾ
			System.out.println("ϢKey: " + key + ", Value: " + value);
			String labLocation = String.valueOf(k)+".1.left.top";
			String fieldLocation = String.valueOf(k)+".2.left.top";
			propertyPanel.add(labLocation,new JLabel(value));

			//TODO ߼عݲͬͣȾͬ
			String[] attrs = ruleOpsMapI.get(value);
			if (attrs == null || attrs.length == 0){
				System.out.println("infoʾֶΡ"+value+"ȡϢʧܣѡã");
			}
			String currentAttributeValue = null;//ǰԵֵȾ
			System.out.println("====================================================================");
			if (this.targetRevision != null && this.targetRevision.size() > 0){
				System.out.println("infoѡж󣬿ʼѡжȾ");

				//ѡжʱĬϽǰѡеĵһΪĬֵȾԱ༭
				TCComponentItem targetItem = this.targetRevision.get(0).getItem();
				//ƻȡͣitem/rev
				String itemType = attrs[0];//item/rev
				String propertyName = attrs[1];//ʵ
				if (itemType.equals("item")){
					currentAttributeValue = targetItem.getProperty(propertyName);//ȡǰԵֵ

				}else {
					currentAttributeValue = targetRevision.get(0).getProperty(propertyName);//ȡǰԵֵ

				}
				//
				if (isLovType(propertyName)){
					System.out.println("ԡ"+propertyName+"ΪLOV");

					Map<String, String> lovList = getUnitValue_display(session,propertyName);
					// б
					JComboBox<String> comboBox = new JComboBox<>();

					// lovListеvalueֵӵб
					for (String lovValue : lovList.values()) {
						comboBox.addItem(lovValue);
					}
					// ĬʾֵdefaultValueϣĬʾѡ
					comboBox.setSelectedItem(currentAttributeValue);
					propertyPanel.add(fieldLocation, comboBox);
					this.textAreaMap.put(propertyName, comboBox); //
				}else {//
					System.out.println("ԡ"+ propertyName+"ͷLOV	");

					JTextArea textArea = new JTextArea(); // JTextArea
					textArea.setColumns(20); // 
					textArea.setLineWrap(true); // Զ
					textArea.setWrapStyleWord(true); // ʻ
					JScrollPane scrollPane = new JScrollPane(textArea);
					System.out.println("KUMA=" + value);
					if (value != null && (value.trim().contains("ע") || "ע".equals(value.trim()))){//ע⴦Ӹ߶
						System.out.println("KUMA:ֶ⴦");
						scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
						textArea.setRows(3);
						scrollPane.setPreferredSize(scrollPane.getPreferredSize()); //  JScrollPane ѡߴ
					}
					//ֵtextArea
					textArea.setText(currentAttributeValue);
					propertyPanel.add(fieldLocation, scrollPane);
					this.textAreaMap.put(key, textArea); // JTextArea浽Map
				}

			}else {
				System.out.println("infoδѡκУ޷ȡѡжȾĬ");
				//ȾĬ
				JTextArea textArea = new JTextArea(); // JTextArea
				textArea.setColumns(20); // 
				textArea.setLineWrap(true); // Զ
				textArea.setWrapStyleWord(true); // ʻ
				propertyPanel.add(fieldLocation, new JScrollPane(textArea));
				this.textAreaMap.put(key, textArea); // JTextArea浽Map
			}
		}




		topPanel.add(propertyPanel, BorderLayout.CENTER);
		topPanel.revalidate();
		topPanel.repaint();//Panel
	}

	/**
	 * ¼
	 * @param models
	 * @param cols
	 */
	private void addActionListener(TCComponent[] models, int[] cols) {
		impTable.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {//
				System.out.println("ѡ¼~");
				try {
					int[] selectedRows = impTable.getSelectedRows();
					int length = selectedRows.length;

					if(length <= 0) {
						System.out.println("ǰѡеĳΪ"+length+"δѡκζ ");
						return;
					}else {
						System.out.println("ǰѡУ"+ArrayUtil.toString(selectedRows));
					}
					//ѡ
					if (chooseRows != null && chooseRows.size() > 0) {
						chooseRows.clear();//µѡǰѡм
					}else {
						chooseRows = new ArrayList<Integer> ();
					}
					
					if (targetRevision != null && targetRevision.size() > 0) {
						targetRevision.clear();
					}else {
						targetRevision = new ArrayList<TCComponentItemRevision>();
					}

					System.out.println("ǰѡУ");

					for (int i = 0; i < selectedRows.length; i++) {
						//ѡ֮һ
						int selectPartRowNum = selectedRows[i];
						System.out.println("=>"+selectPartRowNum+" ;");
						if (revlist != null && revlist.size() > 0) {
							TCComponentItemRevision selectRevision = revlist.get(selectPartRowNum);//ѡеţrevlistлȡжӦİ汾
							if (selectRevision != null) {
								targetRevision.add(selectRevision);
								chooseRows.add(selectPartRowNum);
							}

						}else {
							System.out.println("汾listΪգ");
						}

					}

					if (targetRevision != null && targetRevision.size() > 0) {
						System.out.println("ȾǰѡУ"+Arrays.toString(chooseRows.toArray()));
//						initUi(modelsF, taskF, ruleOpsMapF, colsF, chooseRows);
//						ProcessAttriChangeDialog.this.dispose();
//						new ProcessAttriChangeDialog(session, models, taskF, ruleOpsMapF, colsF, chooseRows, targetRevision);
						updatePropertyPanel(ruleOpsMapF);
						System.out.println("ȾѡУ"+Arrays.toString(chooseRows.toArray()));
					}

				} catch (Exception e1) {
					e1.printStackTrace();
					MessageBox.post(ProcessAttriChangeDialog.this, "" + e1.getMessage(), "ERROR", MessageBox.ERROR);
				}
			}
		});
		remarkBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {//޸԰ť
				System.out.println("޸¼~");
				try {
//					chooseRow = impTable.getSelectedRow();
					System.out.println("ǰѡУ" + impTable.getSelectedRow());
					for (int i = 0; i < chooseRows.size(); i++) {
						System.out.println("޸-ѡУ" + chooseRows.get(i));
					}
					if(chooseRows.size() <= 0) {
						MessageBox.post(ProcessAttriChangeDialog.this, "ѡҪ༭У", "ERROR", MessageBox.ERROR);
						return;
					}
					for (String key : textAreaMap.keySet()){
//						String text = textAreaMap.get(key).getText();//ȡеֵ
						//
						Object component = textAreaMap.get(key);
						String text = getValueByAreaType(component);
						if (text == null){
							System.out.println("infoȡֵ쳣");
						}

						String showAttr = argMap.get(key);//ȡ̲value
						if(text.getBytes().length > 1024) {
							MessageBox.post(ProcessAttriChangeDialog.this, showAttr+"дȹ޷޸ģ", "ERROR", MessageBox.ERROR);
							return;
						}else {
							//ȡ
							for (int t = 0; t < tableHeaderList.size(); t++){
								if (tableHeaderList.get(t).equals(showAttr)){
									for (int i = 0; i < chooseRows.size(); i++) {
										impTable.setValueAt(text, chooseRows.get(i), t);
									}
									break;
								}
							}

						}
					}

					for (int i = 0; i < chooseRows.size(); i++) {
						TCComponentItemRevision rev = revlist.get(chooseRows.get(i));
						TCComponentItem item = rev.getItem();
						if(mark[0].equals("item") && item.isCheckedOut()) {
							MessageBox.post(ProcessAttriChangeDialog.this, item+" ǩ޷޸ģ", "ERROR", MessageBox.ERROR);
							return;
						}else if(mark[0].equals("rev") && rev.isCheckedOut()) {
							MessageBox.post(ProcessAttriChangeDialog.this, rev+" ǩ޷޸ģ", "E      RROR", MessageBox.ERROR);
							return;
						}
						MethodUtil.openByPass(session);
						if(mark[0].equals("item")) {
							for (String key : textAreaMap.keySet()){
//								String value = textAreaMap.get(key).getText();
								Object component = textAreaMap.get(key);
								String inputValue = getValueByAreaType(component);
								if (inputValue == null){
									System.out.println("infoȡֵ쳣");
								}

								item.setProperty(key, inputValue);
							}
						}else if(mark[0].equals("rev")) {
							for (String key : textAreaMap.keySet()){
//								String value = textAreaMap.get(key).getText();
								Object component = textAreaMap.get(key);
								String inputValue = getValueByAreaType(component);
								if (inputValue == null){
									System.out.println("infoȡֵ쳣");
								}
								rev.setProperty(key, inputValue);
							}
						}
					}

					MethodUtil.closeByPass(session);
				}catch(Exception e1) {
					e1.printStackTrace();
					MessageBox.post(ProcessAttriChangeDialog.this, ""+e1.getMessage(), "ERROR", MessageBox.ERROR);
				}finally {
					try {
						MethodUtil.closeByPass(session);
					}catch(Exception e1) {
						e1.printStackTrace();
					}
				}
			}
		});

		exportBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.println("¼~");
				FileInputStream input = null;
				FileOutputStream output = null;
				XSSFWorkbook wb = null;
				try {
					File directory = TCUtil.saveExcelChooser(ProcessAttriChangeDialog.this, "");
					if(directory==null)
						return;
					if(directory.exists())
						directory.delete();
					TCComponentDataset model = (TCComponentDataset) models[1];
					TCComponentTcFile[] files = model.getTcFiles();
					File file = files[0].getFile(System.getProperty("java.io.tmpdir"));
					input = new FileInputStream(file);
					wb = new XSSFWorkbook(input);
					XSSFSheet sheet = wb.getSheetAt(0);
					XSSFRow row;
					XSSFCell cell;
					row = getRow(sheet, cols[0]);
					TableColumnModel cm = impTable.getColumnModel();
					for(int i=0; i<cm.getColumnCount(); i++) {
						cell = getCell(row, i);
						cell.setCellValue(cm.getColumn(i).getHeaderValue().toString());
					}
					for(int i=0; i<impTable.getRowCount(); i++) {
						row = getRow(sheet, i + cols[1]);
						for(int j=0; j<impTable.getColumnCount(); j++) {
							cell = getCell(row, j);
							cell.setCellValue(impTable.getValueAt(i, j).toString());
						}
					}
					output = new FileOutputStream(file.getPath());
					wb.write(output);
					input.close();
					output.close();
					file.renameTo(directory);
					MessageBox.post(ProcessAttriChangeDialog.this, "ɣ", "ʾ", MessageBox.INFORMATION);
				}catch(Exception e1) {
					e1.printStackTrace();
					MessageBox.post(ProcessAttriChangeDialog.this, ""+e1.getMessage(), "ERROR", MessageBox.ERROR);
				}finally {
					if(input!=null)
						try {
							input.close();
						} catch (Exception e) {
							e.printStackTrace();
						}
					if(output!=null)
						try {
							output.close();
						} catch (Exception e) {
							e.printStackTrace();
						}
				}
			}
		});

		closeBtn.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				dispose();
			}
		});
	}
	

	/**
	 *  ʾֵ
	 * @param object
	 * @param setValue
	 */
	private void setModelValue(Object object, String setValue) {
		// TODO Զɵķ
		
	}

	/**
	 * ͻȡֵ
	 * @param component JComboBoxJTextArea
	 * @return
	 */
	private String getValueByAreaType(Object component){
		if (component instanceof JComboBox) {
			// JComboBoxȡѡе
			JComboBox<?> comboBox = (JComboBox<?>) component;
			String selectedItem = (String) comboBox.getSelectedItem();
//			System.out.println("JComboBox selected item: " + selectedItem);
			return selectedItem;
		} else if (component instanceof JTextArea) {
			// JTextAreaȡı
			JTextArea textArea = (JTextArea) component;
			String text = textArea.getText();
//			System.out.println("JTextArea text: " + text);
			return text;
		}
		return null;
	}
	
	private String getProp(String[] ps, TCComponentItem item, TCComponentItemRevision rev) throws Exception {
		if(ps[0].equals("item")) {
			return item.getProperty(ps[1]);
		}else if(ps[0].equals("rev")) {
			return rev.getProperty(ps[1]);
		}
		return "";
	}

	private XSSFRow getRow(XSSFSheet sheet, int num) throws Exception {
		XSSFRow row = sheet.getRow(num);
		if(row==null)
			row = sheet.createRow(num);
		return row;
	}
	private XSSFCell getCell(XSSFRow row, int col) throws Exception {
		XSSFCell cell = row.getCell(col);
		if(cell==null)
			cell = row.createCell(col);
		return cell;
	}

	public class TextAreaRenderer extends JTextArea implements TableCellRenderer {
		private static final long serialVersionUID = 1L;
	     
	    public TextAreaRenderer() {
	        setLineWrap(true); //JTextAreaԶз
	        setWrapStyleWord(true);
		}

		public Component getTableCellRendererComponent(JTable table, Object value,   
	            boolean isSelected, boolean hasFocus, int row, int column) {
			// 㵱еѸ߶   
			int maxPreferredHeight = 22;
			JTextArea cell = new JTextArea();
			for (int i=0; i<table.getColumnCount(); i++) {
				cell.setText("" + table.getValueAt(row, i));
				maxPreferredHeight = Math.max(maxPreferredHeight, 
						(cell.getPreferredSize().width/table.getColumnModel().getColumn(i).getWidth()+1)*cell.getPreferredSize().height+7);
			}
			if (table.getRowHeight(row) != maxPreferredHeight) 
				// Ϲæ   
				table.setRowHeight(row, maxPreferredHeight);
	   
			setText(value == null ? "" : value.toString());   
			fillColor(table,this,isSelected);
			return this;   
	    }
		
		public void fillColor(JTable t,JTextArea l,boolean isSelected ){
			if(isSelected){
				l.setBackground(t.getSelectionBackground());
				l.setForeground(t.getSelectionForeground());
			} else {
	            l.setBackground(t.getBackground());
	            l.setForeground(t.getForeground());
	        }
	    }
	}
}

